package ovh.herisson.Clyde.Services;


import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.TokenRepository;
import ovh.herisson.Clyde.Tables.Token;
import ovh.herisson.Clyde.Tables.User;

import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;
import java.security.SecureRandom;
import java.util.Date;

@Service
public class TokenService {

    TokenRepository tokenRepo;

    public TokenService(TokenRepository tokenRepo){
        this.tokenRepo = tokenRepo;
    }


    public String generateNewToken(){
        byte[] bytes = new byte[64];
        new SecureRandom().nextBytes(bytes);
        for (int i = 0; i < bytes.length; i++) {
            bytes[i] = (byte) (((bytes[i]+256)%256  %95+ 32));
        }
        // will never end up in the catch because of the way that SecureRandom.nextBytes is implemented
        try {
            return new String(bytes,"ISO_8859_1");
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException(e);
        }
    }

    public User getUserFromToken(String token){
        return tokenRepo.getByToken(token).getUser();
    }

    public void saveToken(String token, User user, Date expirationDate){// todo faire qlq chose de l'expDate
        tokenRepo.save(new Token(user,token));
    }
}